//
// Simple program to convert from CLIP-format PNM, ordinary PNM, JPEG,
// BMP or APT to ordinary PNM, BMP or APT.
//
// John Robinson, 2005
//
#include "picture.h"
#include "usage.h"
void chop(colour_picture& in) {
	int maxv = in.max();
	int minv = in.min();
	if ((minv < 0)||(maxv > 255)) {
		cout << "Clipping  range [" << minv << "," << maxv << "] to [";
		if (minv < 0) {
			minv = 0;
			in.min(minv);
		}
		if (maxv > 255) {
			maxv = 255;
			in.max(maxv);
		}
		cout << minv << "," << maxv << "]\n";
	}
}
int main(int argc, char *argv[]) {
	usage("convert inpic outpic");
	colour_picture in(argv[1]);
	char *p = argv[2];
	while(*p) p++;
	while(p > argv[2] && (*p != '.')) p--;
	if (!strcmp(p,".bmp")) {
		cout << "Converting to bmp\n";
		chop(in);
		in.bmpwrite(argv[2]);
	}
	else if (!strcmp(p,".apt")) {
		cout << "Converting to apt\n";
		chop(in);
		in.aptwrite(argv[2]);
	}
	else {
		cout << "Converting to pnm\n";
		in.write(argv[2]);
	}
	return 0;
	}
