//
// Program to code a picture containing values from -63 to + 63
// into a file of symbols where 0-127 represent values, and
// 128-255 represent runs of level 0
//
// John Robinson. February 1997
//
#include <fstream>
#include "usage.h"
#include "picture.h"
int main(int argc, char *argv[])
	{
	usage("rlczeros inpic codefile");
	picture_of_int in(argv[1]);
	ofstream out(argv[2]);
	if (!out) {
		cerr << "Can't open " << argv[2] << endl;
		return -1;
		}
	out << in.nrows() << ' ' << in.ncols() << '\n';
	if (in.min() < -63) {
		cerr << "Picture contains values below -63. Cannot handle\n";
		return -1;
		}
	if (in.max() > 63) {
		cerr << "Picture contains values above 63. Cannot handle\n";
		return -1;
		}
	in += 63;
	int run = 0;	// Assume starts as not run
	int cnt = 0;
	for (int i = 0; i < in.nrows(); i++)
	for (int j = 0; j < in.ncols(); j++)
		{
		int temp = in[i][j];
		if (temp == 63)	// I.e. original value 0
			{
			if (!run)
				cnt = 1;
			else if (cnt == 127) {
				out << (unsigned char) (128+127);
				cnt = 1;
				}
			else
				cnt++;
			run = 1;
			}
		else {
			if (run) {
				out << (unsigned char) (128+cnt);
				run = 0;
				}
			out << (unsigned char) temp;
			}
		}
	if (run)
		out << (unsigned char)(128+cnt);
	out.close();
	return 1;
	}

