//
// CLIP program to threshold a picture at a given value. Uses the point
// callback member function.
//
// John Robinson 1995, 1997
#include <stdlib.h>
#include <limits.h>
#include "usage.h"
#include "picture.h"

static int threshold;
int thresh(int& pel)
// This function is called for every pel in the picture, and maps it to
// 0 or 255 depending on whether it was below or above the threshold.
// Returns 1 if pel was greater than or equal to the threshold value,
// returns 0 otherwise.
	{
	if (pel < threshold)
		{
		pel = 0;
		return 0;
		}
	pel = 255;
	return 1;
	}
int main(int argc, char *argv[])
	{
	usage("thresh inpic outpic threshval");
	//
	// usage checks that the command line has appropriate number of
	// words; if not prints the usage message and exits.
	// See usage.h for how it works.
	picture_of_int in(argv[1]);
	threshold = atoi(argv[3]);
	float prop = (float) in.point(thresh);
	// Here using CLIP's point callback facility to apply thresh
	// to every point in the picture in. The result value is the
	// sum of the return values from the callback.
	cout << "Proportion of pic above threshold = " <<
		prop / (in.nrows()*in.ncols()) << "\n";
	in.write(argv[2]);
	return 1;
	}

