#include "picture.h"	// The header file for CLIP
#include "stdio.h"	// Required for sprintf
int main(int argc, char *argv[]) {
	if (argc != 2) {
		cerr << "Usage: inspect picname\n";
		return -1;
		}
	colour_picture inpic(argv[1]);		// Loads pic given in arg 1
	inpic.show(argv[1]);
	cout << "Picture " << argv[1] << " is ";
	if (inpic.ismonochrome())
		cout << "monochrome";
	else
		cout << "colour";
	cout << " with dimensions " << inpic.nrows();
	cout << " rows by " << inpic.ncols() << " columns\n";
	cout << "Maximum value is " << inpic.max();
	cout << ". Minimum value is " << inpic.min() << ".\n";
	// Now get some information about the picture;
	int x = 0;
	int y = 0;
	while(inpic.closerequested() == 0){	// Until user clicks the
						// window close button
		if (inpic.pointleftbutton() == 1)
			{
			if ((inpic.pointx() != x)||(inpic.pointy() != y)) {
				x = inpic.pointx();	// Get coords of pointer
				y = inpic.pointy();
				cout << "Value at (" << x << "," << y << ") is ";
				if (inpic.ismonochrome()) 
					cout << inpic.mono[y][x];
				else {
					cout << "(" << inpic.red[y][x] << ",";
					cout << inpic.green[y][x] << ",";
					cout << inpic.blue[y][x] << ")";
					}
				cout << "\n";
				}
			}
		}
	return 1;
	}
