#include "picture.h"
int main(int argc, char *argv[]) {
	if (argc < 3) {
		cerr << "Usage: matchtemplate templatepic inpic1 inpic2 ... \n";
		exit(1);
		}
	picture_of_int tpic(argv[1]);	// Template picture
	picture_of_int inpic(argv[2]);
	inpic.show(argv[2]);
	irange trows(0,1,tpic.nrows()-1);
	irange tcols(0,1,tpic.ncols()-1);
	irange onepoint(0);
	for (int argnum = 2; argnum < argc; argnum++) {
		inpic.read(argv[argnum]);	// First time just re-reads
		int matchval;
		int bestmatchval =  100000000;	// A huge number
		int besti, bestj;
		for (int i = 0; i < inpic.nrows(); i += 2) {
			for (int j = 0; j < inpic.ncols(); j += 2) {
				matchval = inpic[i+trows][j+tcols] | tpic;
				// Above line gives absolute difference.
				// Use ^ to get squared difference
				if (matchval < bestmatchval) {
					bestmatchval = matchval;
					besti = i;
					bestj = j;
					}
				}
			}
		// Draw a box at found location
		inpic[besti+trows][bestj+onepoint] = 0;
		inpic[besti+trows][bestj+tpic.ncols()+onepoint] = 0;
		inpic[besti+onepoint][bestj+tcols] = 0;
		inpic[besti+tpic.nrows()+onepoint][bestj+tcols] = 0;
		inpic.reshow(argv[argnum]);
		}
	inpic.inspect();
	return 1;
	}
